// Generated by CoffeeScript 1.6.3
var Base, EventEmitter, Logger, addr, addrs, guid, ips, name, os, _, _i, _len, _ref, _ref1,
  __hasProp = {}.hasOwnProperty,
  __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

EventEmitter = require('events').EventEmitter;

_ = require('../vendor/lodash');

Logger = (function(_super) {
  __extends(Logger, _super);

  function Logger() {
    _ref = Logger.__super__.constructor.apply(this, arguments);
    return _ref;
  }

  Logger.prototype.name = 'Logger';

  Logger.prototype.log = function() {
    var _ref1;
    if ((_ref1 = this.opts) != null ? _ref1.debug : void 0) {
      return console.log.apply(console, [this.toString()].concat([].slice.call(arguments)));
    }
  };

  Logger.prototype.err = function(str) {
    return this.emit('error', new Error("" + this + " " + str));
  };

  Logger.prototype.toString = function() {
    return "" + this.name + ": " + this.id + ":";
  };

  return Logger;

})(EventEmitter);

os = require("os");

guid = function() {
  return (Math.random() * Math.pow(2, 32)).toString(16);
};

ips = [];

_ref1 = typeof os.networkInterfaces === "function" ? os.networkInterfaces() : void 0;
for (name in _ref1) {
  addrs = _ref1[name];
  for (_i = 0, _len = addrs.length; _i < _len; _i++) {
    addr = addrs[_i];
    if (addr.family === 'IPv4') {
      ips.push(addr.address);
    }
  }
}

Base = (function(_super) {
  __extends(Base, _super);

  Base.prototype.name = 'Base';

  function Base(opts) {
    this.opts = opts != null ? opts : {};
    if (_.isString(this.opts)) {
      this.opts = {
        id: this.opts
      };
    }
    _.defaults(this.opts, this.defaults);
    this.guid = guid();
    this.id = this.opts.id || this.guid;
    this.exposed = {
      _pnode: {
        id: this.id,
        guid: this.guid,
        ips: ips.filter(function(ip) {
          return ip !== '127.0.0.1';
        }),
        ping: function(cb) {
          return cb(true);
        }
      }
    };
    _.bindAll(this);
  }

  Base.prototype.expose = function(obj) {
    return _.merge(this.exposed, obj);
  };

  Base.prototype.ips = function() {
    return ips;
  };

  return Base;

})(Logger);

Base.Logger = Logger;

module.exports = Base;
