// Generated by CoffeeScript 1.6.3
var Base, LocalPeer, RemotePeer, locals, pnode, _,
  __hasProp = {}.hasOwnProperty,
  __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

_ = require('../vendor/lodash');

pnode = require('./index');

Base = require('./base');

locals = [];

RemotePeer = (function(_super) {
  __extends(RemotePeer, _super);

  RemotePeer.prototype.name = 'RemotePeer';

  function RemotePeer(local, remote, clientOrServer) {
    var _ref;
    this.local = local;
    this.remote = remote;
    RemotePeer.__super__.constructor.apply(this, arguments);
    _ref = this.remote._pnode, this.id = _ref.id, this.guid = _ref.guid, this.ips = _ref.ips;
    this.clients = {};
    this.servers = {};
    switch (clientOrServer.name) {
      case 'Client':
        this.client = clientOrServer;
        break;
      case 'Server':
        this.server = clientOrServer;
    }
  }

  RemotePeer.prototype.serialize = function() {
    return "" + this.name + " - " + this.id + ": [" + (this.ips.join(',')) + "]";
  };

  RemotePeer.prototype.add = function() {
    return this.log('add!');
  };

  return RemotePeer;

})(Base.Logger);

LocalPeer = (function(_super) {
  __extends(LocalPeer, _super);

  LocalPeer.prototype.name = 'LocalPeer';

  LocalPeer.prototype.defaults = {
    debug: true,
    providePeers: true,
    extractPeers: true,
    hello: 42
  };

  function LocalPeer() {
    var _this = this;
    LocalPeer.__super__.constructor.apply(this, arguments);
    this.peers = {};
    if (this.opts.providePeers) {
      this.expose({
        _pnode: {
          peers: function(cb) {
            return cb(_this.serializePeers());
          }
        }
      });
    }
  }

  LocalPeer.prototype.bindOn = function() {
    var server,
      _this = this;
    server = pnode.server(this.opts);
    server.on('error', function(err) {
      return _this.emit('error', err);
    });
    server.on('remote', this.onPeer);
    server.exposed = this.exposed;
    return server.bindOn.apply(server, arguments);
  };

  LocalPeer.prototype.bindTo = function() {
    var client,
      _this = this;
    client = pnode.client(this.opts);
    client.on('error', function(err) {
      return _this.emit('error', err);
    });
    client.on('remote', this.onPeer);
    client.exposed = this.exposed;
    return client.bindTo.apply(client, arguments);
  };

  LocalPeer.prototype.onPeer = function(remote, clientOrServer) {
    var guid, meta,
      _this = this;
    meta = remote._pnode;
    if (!meta) {
      return;
    }
    if (this.opts.extractPeers && meta.peers) {
      meta.peers(function(p) {
        return _this.log("PEERS on " + meta.id, p);
      });
    }
    guid = meta.guid;
    if (!guid) {
      this.log('peer missing guid');
      return;
    }
    if (this.peers[guid]) {
      return this.peers[guid].add(remote);
    } else {
      return this.peers[guid] = new RemotePeer(this, remote, clientOrServer);
    }
  };

  LocalPeer.prototype.serializePeers = function() {
    var guid, peer, peers, _ref;
    peers = {};
    _ref = this.peers;
    for (guid in _ref) {
      peer = _ref[guid];
      peers[guid] = peer.serialize();
    }
    return peers;
  };

  LocalPeer.prototype.all = function() {
    return this.log('all!');
  };

  LocalPeer.prototype.peer = function() {
    return this.log('one!');
  };

  return LocalPeer;

})(Base);

module.exports = function(opts) {
  var peer;
  peer = new LocalPeer(opts);
  locals.push(peer);
  return peer;
};
