// Generated by CoffeeScript 1.6.3
var Base, Server, dnode, helper, servers, transports,
  __hasProp = {}.hasOwnProperty,
  __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

dnode = require('dnode');

Base = require('./base');

transports = require('./transports');

helper = require('./helper');

servers = [];

Server = (function(_super) {
  __extends(Server, _super);

  Server.prototype.name = 'Server';

  Server.prototype.defaults = {
    debug: true,
    wait: 5000
  };

  function Server() {
    Server.__super__.constructor.apply(this, arguments);
    this.clients = {};
    this.bindOn = this.bind;
  }

  Server.prototype.bind = function() {
    return this.si = transports.bind(this, arguments);
  };

  Server.prototype.unbind = function() {
    var client, e, id, _ref, _ref1;
    _ref = this.clients;
    for (id in _ref) {
      client = _ref[id];
      client.d.end();
    }
    try {
      if (typeof ((_ref1 = this.si) != null ? _ref1.unbind : void 0) === 'function') {
        return this.si.unbind();
      }
    } catch (_error) {
      e = _error;
    }
  };

  Server.prototype.handle = function(read, write) {
    var d,
      _this = this;
    if (read.write && !(write != null ? write.write : void 0)) {
      write = read;
    }
    if (!helper.isReadable(read)) {
      this.err("Invalid read stream");
    }
    if (!helper.isWritable(write)) {
      this.err("Invalid write stream");
    }
    d = dnode(this.exposed);
    d.once('remote', this.onRemote);
    d.on('error', function(err) {
      return _this.log('handle error', err);
    });
    d.on('fail', function(err) {
      return _this.log('handle fail', err);
    });
    read.once('close', d.end);
    return read.pipe(d).pipe(write);
  };

  Server.prototype.onRemote = function(remote, d) {
    var meta,
      _this = this;
    meta = remote._pnode;
    if (!meta) {
      this.log("closing connection, not a pnode client");
      d.end();
      return;
    }
    this.clients[meta.id] = {
      remote: remote,
      d: d
    };
    this.log('connected to client', meta.id);
    this.emit('remote', remote, this);
    return d.once('end', function() {
      _this.log('disconnected from client', meta.id);
      return delete _this.clients[meta.id];
    });
  };

  Server.prototype.client = function(id, callback) {
    var cb, rem, t,
      _this = this;
    rem = this.clientSync(id);
    if (rem) {
      return callback(rem);
    }
    t = setTimeout(function() {
      return _this.removeListener('remote', cb);
    }, this.opts.wait);
    cb = function() {
      rem = _this.clientSync(id);
      if (!rem) {
        return;
      }
      clearTimeout(t);
      _this.removeListener('remote', cb);
      return callback(rem);
    };
    return this.once('remote', cb);
  };

  Server.prototype.clientSync = function(id) {
    var client, i, _ref, _ref1;
    if (typeof id === 'string') {
      return (_ref = this.clients[id]) != null ? _ref.remote : void 0;
    } else if (typeof id === 'number') {
      i = id;
      _ref1 = this.clients;
      for (id in _ref1) {
        client = _ref1[id];
        if (i-- === 0) {
          return client.remote;
        }
      }
      return null;
    } else {
      return this.err("invalid arguments");
    }
  };

  return Server;

})(Base);

module.exports = function(opts) {
  var server;
  server = new Server(opts);
  servers.push(server);
  return server;
};

if (typeof process.on === "function") {
  process.on('exit', function() {
    var server, _i, _len, _results;
    _results = [];
    for (_i = 0, _len = servers.length; _i < _len; _i++) {
      server = servers[_i];
      _results.push(server.unbind());
    }
    return _results;
  });
}

if (typeof process.on === "function") {
  process.on('SIGINT', function() {
    return process.exit();
  });
}
