// Generated by CoffeeScript 1.6.3
var https, pem, pkg, _,
  __slice = [].slice;

https = require('https');

pkg = require('../../package.json');

pem = require('pem');

_ = require('../../vendor/lodash');

exports.bindServer = function() {
  var args, opts, server, si, start, _i,
    _this = this;
  args = 2 <= arguments.length ? __slice.call(arguments, 0, _i = arguments.length - 1) : (_i = 0, []), opts = arguments[_i++];
  server = this;
  start = function() {
    var s;
    s = https.createServer(opts, server.handle);
    s.listen.apply(s, args);
    return _.extend(si, {
      uri: "http://",
      unbind: function() {
        return s.close();
      }
    });
  };
  if (typeof opts === 'object') {
    start();
  } else {
    pem.createCertificate({
      days: 365,
      selfSigned: true
    }, function(err, keys) {
      if (err) {
        server.err(err);
      }
      opts = {
        key: keys.serviceKey,
        cert: keys.certificate
      };
      return start();
    });
  }
  return si = {};
};

exports.bindClient = function() {
  var args, client, opts;
  args = 1 <= arguments.length ? __slice.call(arguments, 0) : [];
  client = this;
  opts = {
    path: '/' + pkg.name,
    rejectUnauthorized: false,
    headers: {
      'user-agent': pkg.name + '/' + pkg.version,
      'transfer-encoding': 'chunked',
      'expect': '100-continue'
    }
  };
  if (typeof args[0] === 'number') {
    opts.port = args.shift();
  } else {
    client.err("bind failed: missing port");
  }
  if (typeof args[0] === 'string') {
    opts.hostname = args.shift();
  }
  return client.createConnection(function(readCallback, writeCallback) {
    return writeCallback(https.request(opts, readCallback));
  });
};
