// Generated by CoffeeScript 1.6.3
var fs, pem, tls, _,
  __slice = [].slice;

tls = require('tls');

fs = require('fs');

pem = require('pem');

_ = require('../../vendor/lodash');

exports.bindServer = function() {
  var args, opts, server, si, start, _i,
    _this = this;
  args = 2 <= arguments.length ? __slice.call(arguments, 0, _i = arguments.length - 1) : (_i = 0, []), opts = arguments[_i++];
  server = this;
  si = {};
  start = function() {
    var s;
    s = tls.createServer(opts, function(stream) {
      return server.handle(stream);
    });
    s.listen.apply(s, args);
    return si.unbind = function() {
      return s.close();
    };
  };
  if (typeof opts === 'object') {
    start();
  } else {
    pem.createCertificate({
      days: 365,
      selfSigned: true
    }, function(err, keys) {
      if (err) {
        server.err(err);
      }
      opts = {
        key: keys.serviceKey,
        cert: keys.certificate,
        rejectUnauthorized: false
      };
      return start();
    });
  }
  return si;
};

exports.bindClient = function() {
  var args, client, opts;
  args = 1 <= arguments.length ? __slice.call(arguments, 0) : [];
  opts = {};
  if (typeof args[0] === 'number') {
    opts.port = args.shift();
  }
  if (typeof args[0] === 'string') {
    opts.hostname = args.shift();
  }
  if (typeof args[0] === 'object') {
    _.merge(opts, args.shift());
  }
  if (opts.rejectUnauthorized === undefined) {
    opts.rejectUnauthorized = false;
  }
  client = this;
  return client.createConnection(function(callback) {
    return callback(tls.connect.call(null, opts));
  });
};
